local media = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("PvPGrid")


function PvPGrid:OnOptionCreate()
	self.options = {
		type = 'group',
		name = GetAddOnMetadata("PvPGrid", "Title"),
		get = function(info)
			return self.db.profile[info[#info]]
		end,
		args = {
			general = {
				type = "group",
				name = L["General"],
				order = 1,
				args = {
					lock = {
						type = "toggle",
						name = L["Lock position"],
						order = 1,
						get = function() 
							return PvPGrid.db.profile.lock 
						end,
						set = function(info, value) 
							PvPGrid.db.profile.lock = value
							if value then
								self.mainframe:EnableMouse(false)
							else
								self.mainframe:EnableMouse(true)
							end
						end,
					},
					gerneal2 = {
						type = "group",
						order = 2,
						inline = true,
						name = L["Baroptions"],
						args = {
							frameheight = {
								type = "range",
								name = L["height"],
								order = 2,
								max = 80,
								min = 6,
								step = 1,
								set = function(info, value)
									self.db.profile.frameheight = value
									width = self.db.profile.framewidth
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										self.mainframe[framename]:SetPoint("TOPLEFT", 0, -10-(i-1)*value)
										self.mainframe[framename]:SetSize(width , value)
										self.mainframe[framename].health:SetSize(width , value)
										self.mainframe[framename].roleicon:SetPoint("TOPLEFT", -value*2-2, 0)
										self.mainframe[framename].roleicon:SetSize(value , value)
										self.mainframe[framename].specicon:SetPoint("TOPLEFT", -value-1, 0)
										self.mainframe[framename].specicon:SetSize(value , value)
										-- medallionscds
										self.mainframe[framename].insi:SetSize(value , value)
										self.mainframe[framename].insi.Icon:SetSize(value , value)
										self.mainframe[framename].insi:SetPoint("TOPRIGHT", value+1, 0)
										self.mainframe[framename].insi.Icon:SetPoint("TOPRIGHT", value+1, 0)
										
										self.mainframe[framename].insi2:SetSize(value , value)
										self.mainframe[framename].insi2.Icon:SetSize(value , value)
										self.mainframe[framename].insi2:SetPoint("TOPRIGHT", 2*value+2, 0)
										self.mainframe[framename].insi2.Icon:SetPoint("TOPRIGHT", 2*value+2, 0)
									end
									self.mainframe['allianceflag']:SetSize(value , value)
									self.mainframe['hordeflag']:SetSize(value, value)
									self.mainframe['netherflag']:SetSize(value, value)
									self.mainframe['blueorb']:SetSize(value , value)
									self.mainframe['purpleorb']:SetSize(value , value)
									self.mainframe['orangeorb']:SetSize(value , value)
									self.mainframe['greenorb']:SetSize(value , value)
								end,
							},
							framewidth = {
								type = "range",
								name = L["width"],
								order = 1,
								max = 500,
								min = 30,
								step = 1,
								set = function(info, value)
									self.db.profile.framewidth = value
									height = self.db.profile.frameheight
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										self.mainframe[framename]:SetSize(value , height)
										self.mainframe[framename].health:SetSize(value , height)
									end
								end,
							},
							lb1 = {
								name = "",
								type = "description",
								order = 3,
							},
							fontsize  = {
								type = "range",
								name = L["FontSize"],
								order = 4,
								max = 50,
								min = 5,
								step = 1,
								set = function(info, value)
									self.db.profile.fontsize = value
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										self.mainframe[framename].fontpercent:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
										self.mainframe[framename].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
										self.mainframe[framename].fonttargetcount:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
										self.mainframe[framename].insi.time.font:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
										self.mainframe[framename].insi2.time.font:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									end
									self.mainframe['allianceflag'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['hordeflag'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['netherflag'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['blueorb'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['purpleorb'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['orangeorb'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['greenorb'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
								end,
							},
							mainfont = {
								type = "select",
								name = L["Font"],
								order = 5,
								values = media:List("font"),
								itemControl = "DDI-Font",
								get = function()
									for i, v in next, media:List("font") do
										if v == self.db.profile.mainfont then return i end
									end
								end,
								set = function(info, value)
									local list = media:List("font")
									local font = list[value]
									self.db.profile.mainfont = font
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										self.mainframe[framename].fontpercent:SetFont(media:Fetch("font", font) , self.db.profile.fontsize, "OUTLINE")
										self.mainframe[framename].fontname:SetFont(media:Fetch("font", font) , self.db.profile.fontsize, "OUTLINE")
										self.mainframe[framename].fonttargetcount:SetFont(media:Fetch("font", font) , self.db.profile.fontsize, "OUTLINE")
										self.mainframe[framename].insi.time.font:SetFont(media:Fetch("font", font) , self.db.profile.fontsize, "OUTLINE")
										self.mainframe[framename].insi2.time.font:SetFont(media:Fetch("font", font) , self.db.profile.fontsize, "OUTLINE")
									end
								end,
							},
							lb2 = {
								name = "",
								type = "description",
								order = 6,
							},
							percenttext = {
								type = "select",
								name = L["HPtext"],
								order = 6.1,
								values =  {
									PERCENT = L["percent and value"],
									VALUE = L["value"],
									NONE = L["none"],
								},
								get = function() 
									return PvPGrid.db.profile.percenttext 
								end,
								set = function(info, value)
									self.db.profile.percenttext = value
									PvPGrid:Refresh()
									PvPGrid:updategrid()
								end,
							},
							wordwrap = {
								type = "range",
								name = L["wordwrap"],
								order = 6.2,
								max = 99,
								min = 3,
								step = 1,
								set = function(info, value)
									self.db.profile.wordwrap = value
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										if not self.playergrid[i] then
										
										else
											if PvPGrid.db.profile.servername then
												self.mainframe[framename].fontname:SetText(self:formatUpToX(self.playergrid[i].name, self.db.profile.wordwrap))
											end
										end
									end
								end,
							},
							lb2a = {
								name = "",
								type = "description",
								order = 6.3,
							},
							statusbarframe = {
								type = "select",
								name =  L["Bar texture"],
								order = 7,
								dialogControl = 'LSM30_Statusbar',
								values = AceGUIWidgetLSMlists.statusbar,
								get = function() return self.db.profile.statusbarframe end,
								set = function(win, key)
									self.db.profile.statusbarframe = key
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										self.mainframe[framename].health:SetStatusBarTexture(media:Fetch("statusbar", key))
									end
								end,
							},
							lb3 = {
								name = "",
								type = "description",
								order = 8,
								width = 'double'
							},
							servername = {
								type = "toggle",
								name = L["show servername"],
								order = 9,
								get = function() 
									return PvPGrid.db.profile.servername 
								end,
								set = function(info, value) 
									PvPGrid.db.profile.servername = value
									
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										local frame = PvPGrid.mainframe[framename].fontname
										if PvPGrid.playergrid[i] then
											if PvPGrid.db.profile.servername then
												self.mainframe[framename].fontname:SetText(self:formatUpToX(self.playergrid[i].name, self.db.profile.wordwrap))
											else
												local playername, servername = strsplit("-", PvPGrid.playergrid[i].name)
												frame:SetText(playername)
											end
										end
									end
								end,
							},
							roleicon = {
								type = "toggle",
								name = L["show roleicon"],
								order = 10,
								get = function() 
									return PvPGrid.db.profile.roleicon 
								end,
								set = function(info, value) 
									PvPGrid.db.profile.roleicon = value
									
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										local frame = PvPGrid.mainframe[framename].roleicon
										if PvPGrid.playergrid[i] then
											if PvPGrid.db.profile.roleicon then
												frame:Show()
											else
												frame:Hide()
											end
										end
									end
								end,
							},
							lb4 = {
								name = "",
								type = "description",
								order = 11,
							},
							specicon = {
								type = "toggle",
								name = L["show specicon"],
								order = 12,
								get = function() 
									return PvPGrid.db.profile.specicon 
								end,
								set = function(info, value) 
									PvPGrid.db.profile.specicon = value
									local height = self.db.profile.frameheight
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										local frame = PvPGrid.mainframe[framename]
										
										if PvPGrid.playergrid[i] then
											if PvPGrid.db.profile.specicon then
												frame.specicon:Show()
												frame.roleicon:SetPoint("TOPLEFT", -height*2-2, 0)
											else
												frame.specicon:Hide()
												frame.roleicon:SetPoint("TOPLEFT", -height-1, 0)
											end
										end
									end
								end,
							},
							barcolor = {
								type = "toggle",
								name = L["show evertime barcolors"],
								order = 14,
								width = 'double',
								get = function() 
									return PvPGrid.db.profile.barcolor 
								end,
								set = function(info, value) 
									PvPGrid.db.profile.barcolor = value
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										local frame = PvPGrid.mainframe[framename]
										local alphastatusbar =  0.3
										if PvPGrid.playergrid[i] then
											for j = 1, #PvPGrid.Classinfos[PvPGrid.playergrid[i].class] do
												if PvPGrid.playergrid[i].spec == PvPGrid.Classinfos[PvPGrid.playergrid[i].class][j].specname then
													local classColor = PvPGrid.playergrid[i].class and RAID_CLASS_COLORS[PvPGrid.playergrid[i].class] or NORMAL_FONT_COLOR;	
													if GetCVar("nameplateShowEnemies") == '1' and PvPGrid.db.profile.barcolor == false then
														self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, alphastatusbar)
													else
														self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)
													end
												end
											end
										end
									end
								end,
							},
						},
					},
				
					gerneal3 = {
						type = "group",
						order = 3,
						inline = true,
						name = L["Keybind Setup"],
						args = {
							leftbuttontype = {
								type = "select",
								name = L["Left Button"],
								order = 1,
								values =  {
									TARGET = L["target"],
									FOCUS = L["focus"],
									COSTUM = L["costum"],
									MOUSEOVER = L["mouseover"],
								},
								get = function() 
									return PvPGrid.db.profile.leftbuttontype 
								end,
								set = function(info, value)
									self.db.profile.leftbuttontype = value
									if value == 'TARGET' or value == 'FOCUS' then
										
									end
									PvPGrid:Refresh()
									PvPGrid:updategrid()
								end,
							},
							leftbutton = {
								type = "input",
								name = '',--L["input"],
								order = 2,
								width = 'double',
								disabled = function()
									local leftbuttontype = PvPGrid.db.profile.leftbuttontype 
									if leftbuttontype == 'TARGET' or leftbuttontype == 'FOCUS' then
										return true
									end
								end,
								get = function() 
									return PvPGrid.db.profile.leftbutton 
								end,
								set = function(info, value) 
									PvPGrid.db.profile.leftbutton = value
									PvPGrid:updategrid()
								end,
							},
							lb101 = {
								name = "",
								type = "description",
								order = 3,
							},
							rightbuttontype = {
								type = "select",
								name = L["Right Button"],
								order = 4,
								values =  {
									TARGET = L["target"],
									FOCUS = L["focus"],
									COSTUM = L["costum"],
									MOUSEOVER = L["mouseover"],
								},
								get = function() 
									return PvPGrid.db.profile.rightbuttontype 
								end,
								set = function(info, value)
									self.db.profile.rightbuttontype = value
									if value == 'TARGET' or value == 'FOCUS' then
										
									end
									PvPGrid:Refresh()
									PvPGrid:updategrid()
								end,
							},
							rightbutton = {
								type = "input",
								name = '',--L["input"],
								order = 5,
								width = 'double',
								disabled = function()
									local rightbuttontype = PvPGrid.db.profile.rightbuttontype 
									if rightbuttontype == 'TARGET' or rightbuttontype == 'FOCUS' then
										return true
									end
								end,
								get = function() 
									return PvPGrid.db.profile.rightbutton 
								end,
								set = function(info, value) 
									PvPGrid.db.profile.rightbutton = value
									PvPGrid:updategrid()
								end,
							},
							lb102 = {
								name = "",
								type = "description",
								order = 6,
							},
							middlebuttontype = {
								type = "select",
								name = L["Middle Button"],
								order = 7,
								values =  {
									TARGET = L["target"],
									FOCUS = L["focus"],
									COSTUM = L["costum"],
									MOUSEOVER = L["mouseover"],
								},
								get = function() 
									return PvPGrid.db.profile.middlebuttontype 
								end,
								set = function(info, value)
									self.db.profile.middlebuttontype = value
									if value == 'TARGET' or value == 'FOCUS' then
										
									end
									PvPGrid:Refresh()
									PvPGrid:updategrid()
								end,
							},
							middlebutton = {
								type = "input",
								name = '',--L["input"],
								order = 8,
								width = 'double',
								disabled = function()
									local middlebuttontype = PvPGrid.db.profile.middlebuttontype 
									if middlebuttontype == 'TARGET' or middlebuttontype == 'FOCUS' then
										return true
									end
								end,
								get = function() 
									return PvPGrid.db.profile.middlebutton 
								end,
								set = function(info, value) 
									PvPGrid.db.profile.middlebutton = value
									PvPGrid:updategrid()
								end,
							},
						},
					},
				},
			},
		},
	}



	self.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("PvPGrid", PvPGrid.options)
	
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("PvPGrid", "PvPGrid", nil, "general")
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("PvPGrid", "Profiles", "PvPGrid", "profiles")

end

function PvPGrid:Refresh()
	LibStub("AceConfigRegistry-3.0"):NotifyChange("PvPGrid")
end


function PvPGrid:SetupOptions()
	self:RegisterChatCommand("pvpgrid", "ChatCommand")
end

function PvPGrid:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory('PvPGrid')
		InterfaceOptionsFrame_OpenToCategory('PvPGrid')
	else
		--LibStub("AceConfigCmd-3.0").HandleCommand(PvPGrid, "pvpgrid", "PvPGrid", input)
	end
end
